#include <iostream>
#define int long long
using namespace std;
int v[1000005];
signed main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n;
    int k;
    cin>>n>>k;
    int maxi=-1;
    for(int i=1;i<=n;i++)
    {
        cin>>v[i];
        maxi=max(maxi,v[i]);
    }
    int pow=1;
    while(pow<=maxi)
    {
        pow*=2;
    }
    pow--;
    int res=0;
    for(int rez=0;rez<=pow;rez++)
    {
        int cate=1;
        int j=1;
        int orr=0;
        while(j<=n && cate<=k)
        {
            orr=(orr|v[j]);
            if((orr&rez)==rez)
            {
                orr=0;
                cate++;
            }
            j++;
        }
        if(cate>k)
        {
            res=rez;
        }

    }
    cout<<res;
    return 0;
}
